<?php
/*
Plugin Name: Likno Web Scroller WordPress Plugin
Plugin URI: http://www.likno.com/jquery-scroller/wordpress-scroller.html
Description: WordPress plugin for the Likno Web Scroller Builder - Create stylish, feature-rich scrollers/sliders for your blogs!
Version: 1.1.2
Author: Likno Software
Author URI: http://www.likno.com/ 
*/

/*

NOTE:

This plugin is licensed under the GNU General Public License (GPL).

As such, you may use the source code of this plugin as you wish.
This plugin is used as a bridge to a non-GPL licensed software (WebScrollerBuilder PRO) that is a property of Likno Software.

The license of Likno Web Scroller Builder  states that a WordPress scroller can be used in **one single domain**.

Thus, the part of the code below that confirms that the scrollers are used only in one domain **cannot** be changed/removed.

*/

global $lwscPluginInstance;
$lwscPluginInstance = new LWSC_Plugin();

class LWSC_Plugin{
    public $optionsMessage, $databaseMessage, $LWSC_ver , $lwsc_total_scrollers, $wpdb, $dataArray,$lwsc_table_name,$lwsc_is_loaded,$lwsc_toload,$lwsc_excluded ;
	
	function LWSC_Plugin(){
		global $wpdb, $wp_version;
		$this->wpdb = $wpdb;

		$this->lwsc_toload = array();
		add_action( 'init', array($this,'LWSC_init_hook' ));
		add_action('init', array($this, 'LWSC_addbuttons'));
		//add_action('wp_head', array($this, 'LWSC_head_hook'));
		add_action('admin_menu', array($this, 'LWSC_add_option_pages'));
		add_action('wp_footer',array ($this,'LWSC_generate_linking_code'));
		add_shortcode( 'likno_scroller', array($this, 'LWSC_shortcode') );
		add_action('wp_ajax_lwsc_tinymce', array($this, 'lwsc_tinymce'));
		add_action( 'admin_init', array($this,'LWSC_addmin_hook' ));
		if((float)$wp_version>=2.8){
			include_once ABSPATH . 'wp-content/plugins/webscrollerbuilder-wordpress-plugin/widgetClass.php';
			add_action('widgets_init', create_function('', 'return register_widget("Widget_WebScrollerBuilder");'));
		}

	}
	
	function LWSC_init_hook(){
		global $lwsc_table_name, $lwsc_total_scrollers, $LWSC_ver;
		$this->lwsc_table_name = $lwsc_table_name = $this->wpdb->prefix . "lwsc";
		include_once ABSPATH . 'wp-content/plugins/webscrollerbuilder-wordpress-plugin/include.php';
		wp_enqueue_script( 'jquery' );
		$LWSC_ver = $this->LWSC_ver = '1.1.2';


		$this->databaseMessage = lwsc_set_first_time_options();
		if (!empty($this->databaseMessage))
			$this->databaseMessage = "<div class=\"updated fade\" style=\"margin-top: 20px;\"><strong>".$this->databaseMessage."</strong></div>";
		$this->lwsc_total_scrollers = $lwsc_total_scrollers = $this->wpdb->get_var($this->wpdb->prepare("SELECT COUNT(*) FROM $this->lwsc_table_name;", null));
	}
	
	/*
	function LWSC_head_hook(){
		global $lwsc_table_name, $lwsc_total_scrollers, $LWSC_ver;
		  $load_it = true;
			 $myrows = $this->wpdb->get_results( "SELECT * FROM $this->lwsc_table_name WHERE active = 1 order by id" );
	}
	*/
	/* 
	 * Add options page
	 */
	function LWSC_add_option_pages() {
		if (function_exists('add_options_page')) {
			$page = add_options_page('Likno Web Scroller WordPress Plugin', 'Likno Web Scroller Plugin', 8, __FILE__, array($this,'LWSC_options_page'));
		}
		add_action( 'admin_print_styles-' . $page,  array($this,'LWSC_admin_styles' ));
	}
	
	function lwsc_wp_settings_link($lwsc_links) {
		$lwsc_settings_link = '<a href="options-general.php?page=webscrollerbuilder-wordpress-plugin/webscrollerbuilder-wordpress.php">Settings</a>';
		array_unshift($lwsc_links, $lwsc_settings_link);
		return $lwsc_links;
	}
	
	/*
	 * Initialization of the admin panel.
	 */
	function LWSC_addmin_hook(){
		if (!session_id()){
			session_start();
		}
		$lwsc_plugin = plugin_basename(__FILE__);
		
		add_filter("plugin_action_links_$lwsc_plugin", array($this, 'lwsc_wp_settings_link' ));
		/* Register our stylesheet. */
		wp_register_script( 'LWSCScript', plugins_url('/script.js', __FILE__) );
		wp_register_script( 'ZeroClipboard', plugins_url('/ZeroClipboard.js', __FILE__) );
		wp_register_style( 'LWSCStylesheet', plugins_url('/stylesheet.css',__FILE__ ));
	}
	
	/*
	 * Add admin panel styles AND scripts
	 */
	function LWSC_admin_styles() {
		/*
		* It will be called only on your plugin admin page, enqueue our stylesheet here
		*/
		wp_enqueue_style( 'LWSCStylesheet' );
		wp_enqueue_script( 'LWSCScript' );
		wp_enqueue_script( 'ZeroClipboard' );
	}
	/* 
	 * Generate options page
	 */
	function LWSC_options_page() {
?>
<script type="text/javascript">
	ZeroClipboard.setMoviePath( '<?php echo plugins_url('/ZeroClipboard.swf', __FILE__)?>' );
</script>
        <div style="max-width: 980px; margin-left: 15px;">

	<span class="wrap">
	<h2>Likno Web jQuery Scroller Plugin v<?php echo $this->LWSC_ver; ?></h2>

<?php
		echo $this->databaseMessage;
		if (isset($_SESSION['message'])){
			echo $_SESSION['message'];
			unset ( $_SESSION['message'] );
		}
?>
		<p>For information and updates, please visit: 
		<a href="http://www.likno.com/jquery-scroller/wordpress-scroller.html">http://www.likno.com/jquery-scroller/wordpress-scroller.html</a></p>
<?php
		/* Display a message in the Options page if the scroller version is outdated
		NOTE: we do not check date as we have to recheck to display the message to the admin */
		
		if (get_option('LWSC_Check_show')) {
			$LWSC_buildText = LWSC_check();
			if ($LWSC_buildText != '') echo $LWSC_buildText;
			else update_option('LWSC_Check_show', FALSE);
		}
?>
	</span>
	<br />
        <br />

        <form method="post" enctype="multipart/form-data" id="theform1" name="theform1" action="<?php echo get_bloginfo('url')."/wp-content/plugins/webscrollerbuilder-wordpress-plugin/actions.php"; ?>" >
        <div style="text-align: right;">
            <button class="button" type="button" onclick="theform1.theaction.value='createnew'; theform1.LWSC_selected_tab_c.value=theform.LWSC_selected_tab.value;theform1.submit();">Create New</button>
        <button <?php if ($this->lwsc_total_scrollers == 1) echo "disabled='disabled'"; ?>class="button" type="button" onclick="theform1.theaction.value='delete';theform1.LWSC_tabs_id.value = eval('theform.LWSC_tabs_id_'+theform.LWSC_selected_tab.value + '.value'); theform1.LWSC_selected_tab_c.value=theform.LWSC_selected_tab.value;theform1.submit();">Delete</button>
        </div>
        <table id="uploader">
		<tr>
                    <td width="250">
                        <strong>Upload compiled ZIP file of your scroller: "<i id="upload_form_tabs_name"></i>"</strong></td>
		<td>
                    <input name="LWSC_files_zip" type="file" />
                    <input type="hidden" name="theaction" value="zip_update"/>
                    <input id="LWSC_selected_tab_c" name="LWSC_selected_tab_c" type="hidden" value="<?php echo get_option('LWSC_selected_tab');?>"/>
                    <input type="hidden" name="LWSC_tabs_id" value=""/>
                    <input type="button" name="zip_update" value="Upload ZIP file" onclick="theform1.LWSC_tabs_id.value = eval('theform.LWSC_tabs_id_'+theform.LWSC_selected_tab.value + '.value');theform1.LWSC_selected_tab_c.value=theform.LWSC_selected_tab.value;theform1.submit();"/>
                     <input type="hidden" name="abspath" value="<?php echo ABSPATH; ?>"/>
    <input type="hidden" name="ref" value="<?php echo admin_url("options-general.php?page=webscrollerbuilder-wordpress-plugin/webscrollerbuilder-wordpress.php"); ?>"/>
                </td>
                </tr>
                <tr>
                    <td width="250">&nbsp;</td>
		<td class="lwsc_itemInfo">
                    Select the ZIP file produced by the Likno Web Scroller Builder interface (containing the compiled scroller files). Then click the "Upload ZIP file" button and the scroller files will be added (or updated) online.<br />
		</td>
                </tr>
        </table>
        </form>
        <?php $myrows = $this->wpdb->get_results( "SELECT * FROM $this->lwsc_table_name" );?>

        <form method="post" enctype="multipart/form-data" id="theform" name="theform" action="<?php echo get_bloginfo('url')."/wp-content/plugins/webscrollerbuilder-wordpress-plugin/actions.php"; ?>" >
            <input type="hidden" name="abspath" value="<?php echo ABSPATH; ?>"/>
            <input type="hidden" name="ref" value="<?php echo admin_url("options-general.php?page=webscrollerbuilder-wordpress-plugin/webscrollerbuilder-wordpress.php"); ?>"/>
            <input id="LWSC_selected_tab" name="LWSC_selected_tab" type="hidden" value="<?php echo get_option('LWSC_selected_tab');?>"/>
	<table>
		<tr>
                    <td width="250">
                        <strong>Online folder for scroller files:</strong>
                    </td>
		<td>
                    <input id="LWSC_the_path" name="LWSC_the_path" onkeyup="lwsc_set_path();" onchange="lwsc_set_path();" type="text" size="30" value="<?php echo get_option('LWSC_the_path'); ?>"/>&nbsp;&nbsp;(relative to blog's root folder)
                </td>
                </tr>
		<tr>
                    <td width="250">&nbsp;</td>
		<td class="lwsc_itemInfo">
			Every time you compile your Likno Web Scroller Builder project you should also upload the produced ZIP file online (see above). Its content (scroller files) are then automatically added by the plugin to this folder.
                                                <br><?php echo get_bloginfo('url');?><span id="LWSC_the_path"><?php echo get_option('LWSC_the_path');?></span>
                                                <br>(note: you might need to create this online folder yourself)
		</td>
                </tr>
	</table>
	
	<div class="submit" style="text-align: right;">
		<input type="button" name="info_update" value="Save settings &raquo;" onclick="theform.theaction.value='info_update'; lwsc_form_validate();"/>
	
	</div>
	<div id="LWSC_scroller_wrapper">
		<div id="LWSC_scrollerHeaders">
<?php 
		for ($lwsc=0; $lwsc<$this->lwsc_total_scrollers; $lwsc++) {
			echo "<div class='LWSC_scroller_header' style='color: #".($myrows[$lwsc]->active ?"0099":"9900")."00;' id='LWSC_scroller_header_$lwsc' onclick='lwsc_show_tab($lwsc)'>". $myrows[$lwsc]->name ."</div>";
		}
?>
		</div>
		<div id="LWSC_scrollerBodies">
<?php 
		for ($lwsc=0; $lwsc<$this->lwsc_total_scrollers; $lwsc++) {
?>
                    <div class='lwsc_tab_body' id='LWSC_tab_body_<?php echo $lwsc;?>'>
				<div>
                                    <input type="hidden" name="LWSC_tabs_id_<?php echo $lwsc;?>" value="<?php echo $myrows[$lwsc]->id?>"/>
                                    <input id="LWSC_tabs_active_<?php echo $lwsc;?>" name="LWSC_tabs_active_<?php echo $lwsc;?>" onclick="lwsc_uncheck(<?php echo $lwsc;?>);" type="checkbox" value="true" <?php if( $myrows[$lwsc]->active) echo "checked='checked'"; ?> /> <strong>Show "<span id="lwsc_active_name_<?php echo $lwsc?>"><?php echo $myrows[$lwsc]->name;?></span>" in blog</strong>
				&nbsp;&nbsp;&nbsp;<?php if (!$myrows[$lwsc]->active) { ?><span id='LWSC_unchecked_<?php echo $lwsc;?>' style='color:#990000;'>Unchecked! (this scroller will not appear in your blog)</span><?php } else { ?><span id='LWSC_unchecked_<?php echo $lwsc;?>' style='color:#009900;'>(this scroller will appear in your blog)</span><?php } ?>
                                </div>
				<div style="padding-left: 19px; margin-top: 13px;"><strong>scroller name: </strong> <input maxlength="256" onkeyup="lwsc_name_change(<?php echo $lwsc;?>, this.value);" onchange="lwsc_name_change(<?php echo $lwsc;?>, this.value);" id="LWSC_tabs_name_<?php echo $lwsc;?>"name="LWSC_tabs_name_<?php echo $lwsc;?>" type="text" size="30" value="<?php echo $myrows[$lwsc]->name ?>" original="<?php echo $myrows[$lwsc]->name ?>"/><span class="lwsc_name_notice" id="lwsc_name_notice_<?php echo $lwsc;?>"></span></div>
				<div style="padding-left: 19px;" class="lwsc_itemInfo">Please make sure that the "scroller name" value matches the value in the "Compiled Javascript Project" property of your Likno Web Scroller Builder project file (<i>Tools > Project Properties > Compile Properties</i>). <a href="javascript:void(0)" onclick="LWSC_folder_info('',<?php echo $lwsc;?>);">show me</a></div>
				<div id="LWSC_folder_info_<?php echo $lwsc;?>" style="margin-top: 20px; display: none; background-color: #FEFCF5; border: #E6DB55 solid 1px;">
					<table>
						<tr>
                                                    <td style="width: 800px; text-align: center; padding-top: 10px; padding-bottom: 10px;">
                                                        <strong>More info</strong> - <a href="javascript:void(0)" onclick="LWSC_folder_info('none',<?php echo $lwsc;?>);">close</a>
                                                    </td>
                                                </tr>
						<tr>
                                                    <td style="width: 800px; text-align: center; padding-top: 0px; padding-bottom: 10px;">
							<img src="<?php echo get_bloginfo('url');?>/wp-content/plugins/webscrollerbuilder-wordpress-plugin/scrollername.png" alt="Project Name" title="Project Name"/>
                                                        <br />
                                                        Compiled Javascript Project (see <span style="color: red;">1</span>) and scroller name (see <span style="color: red;">2</span>) must be the same
                                                        <br />
                                                        <img src="<?php echo get_bloginfo('url');?>/wp-content/plugins/webscrollerbuilder-wordpress-plugin/scrollernamesec.png" alt="Scroller Name" title="Scroller Name"/>
                                                    </td>
                                                </tr>
						<tr>
                                                    <td style="width: 800px; text-align: center; padding-top: 0px; padding-bottom: 10px;">
							<a href="javascript:void(0)" onclick="LWSC_folder_info('none',<?php echo $lwsc;?>);">close</a>
                                                            </td>
                                                </tr>
                                        </table>
				</div>
                                <br />
                                <div>
                                    <fieldset id="lwsc_type_fieldset_<?php echo $lwsc;?>">
                                    <input onclick="lwsc_print_div(this.checked,<?php echo $lwsc?>);" type="checkbox" name="lwsc_type_<?php echo $lwsc?>" value="embedded" <?php checked( $myrows[$lwsc]->print_div, 1 ) ?> /> <strong>Print 'DIV' element</strong><br />
                                    <div id="lwsc_embeddedDetails_<?php echo $lwsc?>" <?php if ( $myrows[$lwsc]->print_div ==  0 ) :?> style="display: none" <?php endif;?>>A 'DIV' element will be produced with this id: <input readonly type="text" id="lwsc_divname<?php echo $lwsc?>" value="lwscAnchor-<?php echo $myrows[$lwsc]->name?>" style="width: 200px;"/>
                                        
										<span style="color:#009900">(copy this element id) </span>
                                       </div>
                                </fieldset>
                                </div>
                                <br />
                                <div class="LWSC_section">Scroller Positioning Method</div>
                                <div style="padding: 20px 0;">Please select a scroller position where you want your scroller to appear:
				<select style="margin-left: 20px;" onchange="lwsc_tabs_position(this.value , <?php echo $lwsc;?>)" name="lwsc_tabs_position_<?php echo $lwsc;?>" id="lwsc_tabs_position_<?php echo $lwsc;?>">
                                            <option value="shortcode" <?php selected( isset( $myrows[$lwsc]->position ) && $myrows[$lwsc]->position == "shortcode" ); ?>>shortcode</option>
                                            <option value="template_tag" <?php selected( isset( $myrows[$lwsc]->position ) && $myrows[$lwsc]->position == "template_tag" ); ?>>template tag</option>
                                            <?php global $wp_registered_sidebars;
                                            global $wp_version;
                                            if ((float)$wp_version>=2.2 &&  count($wp_registered_sidebars > 1)):?>
                                            <option value="lwsc_widget" <?php selected( isset( $myrows[$lwsc]->position ) && $myrows[$lwsc]->position == "lwsc_widget" ); ?>>widget</option>
                                            <?php endif;?>
                                        </select>
                                     <div class="lwsc_tabs_position" id="lwsc_shortcode_position_<?php echo $lwsc;?>" <?php if ($myrows[$lwsc]->position != 'shortcode') echo 'style="display: none;"';?>>You have selected the <em>’shortcode’</em> positioning method. This means that you can add this scroller inside the post or page that you want, using the visual editor.</div>
                                    <div class="lwsc_tabs_position" id="lwsc_template_tag_position_<?php echo $lwsc;?>" <?php if ($myrows[$lwsc]->position !="template_tag") echo 'style="display: none;"';?>>
                                    Copy and paste this code in the template file where you want the scroller to appear.
                                    <br />
                                        <textarea id="template_tag_code_<?php echo $lwsc?>" cols="45" rows="5">
&lt;?php if (function_exists('lwsc_template_tag'))
    lwsc_template_tag('<?php echo $myrows[$lwsc]->name?>');?&gt;

                                    </textarea>
                                           
											<span style="color:#009900">(copy this code) </span>

                                    </div>
                                    <div class="lwsc_tabs_position" id="lwsc_widget_position_<?php echo $lwsc;?>" <?php if ($myrows[$lwsc]->position != "lwsc_widget") echo 'style="display: none;"';?>>
                                     You have selected the <em>'Widget'</em> positioning method.
                                        A widget instance for this scroller is initially created and found in the <a href="<?php echo admin_url('widgets.php');?>#wp_inactive_widgets">widgets administration page</a>, under the "Inactive Widgets" section. Just drag this widget instance and drop it inside the Widget Area that you want.</div>

                        </div>
                                </div>
<?php
		}	// end of tab body for loop
?>
		</div>	<!-- tab_bodies -->
	</div>	<!-- tab_wrapper -->
	<br>
	<br>
	<div style="text-align: center;" class="lwsc_itemInfo"><span style="color:#990000;">Note:</span> Always click the "Save settings" button below to apply your changes. If you leave this page without saving you will lose your unsaved changes.</div>
	<div class="submit" style="text-align: center;">
		<input type="button" name="info_update" value="Save settings &raquo;" onclick="theform.theaction.value='info_update'; lwsc_form_validate();;"/>
	</div>
	
	<input type="hidden" name="theaction" value="" />
	<script type="text/javascript">
            LWSC_TOTAL_TABS_JS = <?php echo $this->lwsc_total_scrollers?>;
            lwsc_show_tab(<?php echo get_option('LWSC_selected_tab'); ?>);
        </script>
	
</form>
</div>	
<?php
	}	// END of LWSC_options_page()
	
	function LWSC_generate_linking_code() {
		$myrows = $this->wpdb->get_results("SELECT * FROM $this->lwsc_table_name WHERE name in (".implode(",", $this->lwsc_toload).") order by id");
		$i=0;
		for ($i=0; $i<count($myrows); $i++) {
			$lwsc_name = $myrows[$i]->name;
			$output= "<!-- ******** BEGIN LIKNO WEB SCROLLER CODE FOR ".$lwsc_name." ******** -->\n";
			$output .= "<script type=\"text/javascript\">var lwscLinkedBy=\"LiknoWebScroller [1]\",lwscName=\"".$lwsc_name."\",lwscBN=\"WP\";</script>\n
			<script charset=\"UTF-8\" src=\"".get_bloginfo('url') . get_option('LWSC_the_path').str_replace('-','_',$lwsc_name)."/".$lwsc_name.".js\" type=\"text/javascript\"></script>\n
			<!-- ******** END LIKNO WEB SCROLLER CODE FOR ".$lwsc_name." ******** -->";
			echo $output;
		}
	}
	/* 
	 * Initialize query var for sitemap permalinks
	 */
	function LWSC_query_vars ( $lwsc_vars ) {
		$lwsc_vars[] = "pg";
		return $lwsc_vars;
	}

	//add_filter('query_vars', 'LWSC_query_vars');
	function LWSC_shortcode( $atts ) {
		extract( shortcode_atts( array(
			'name' => 'tabs1',
			'everywhere' => false
		), $atts ) );
		if (!in_array($name, $this->lwsc_toload)){
			if (is_singular() || $everywhere){
				$name = $this->wpdb->get_var("SELECT name from $this->lwsc_table_name where name = '$name' && position = 'shortcode' and active = 1");
				if (!empty($name)){
					$this->lwsc_toload[] = "'".$name."'";
					if ($this->wpdb->get_var("SELECT print_div from $this->lwsc_table_name where name = '$name' ")== 1){
						return "<span style='display: block;' id='lwscAnchor-$name'></span>";
					} else return "";
				}
				return "";
			} else return "";
		} else return "";
	}

	function LWSC_addbuttons() {
		// Don't bother doing this stuff if the current user lacks permissions
		if ( ! current_user_can('edit_posts') && ! current_user_can('edit_pages') )
			return;

		// Add only in Rich Editor mode
		if ( get_user_option('rich_editing') == 'true') {
			add_filter("mce_external_plugins", array($this, "LWSC_add_tinymce_plugin"));
			add_filter('mce_buttons', array($this, 'LWSC_register_button'));
		}
	}

	function LWSC_register_button($buttons) {
		array_push($buttons, "|", "lwsc");
		return $buttons;
	}
	// Load the TinyMCE plugin : editor_plugin.js (wp2.5)
	function LWSC_add_tinymce_plugin($plugin_array) {
		$plugin_array['lwsc'] = get_bloginfo('url').'/wp-content/plugins/webscrollerbuilder-wordpress-plugin/editor_plugin.js';
		return $plugin_array;
	}
	// init process for button control
	function lwsc_tinymce() {
		if ( !current_user_can('edit_pages') && !current_user_can('edit_posts') )
			die(__("You are not allowed to be here"));
		require_once('LWSC_tinymce.php');
			die();
	}
//add_action('loop_start','lwsc_floated' );
}

function lwsc_template_tag($name){
    global $lwscPluginInstance;
    if ($lwscPluginInstance->wpdb->get_var("SELECT position from $lwscPluginInstance->lwsc_table_name where name = '$name' and active = 1 ")=="template_tag"){
        $lwscPluginInstance->lwsc_toload[]= "'".$name."'";
        if ($lwscPluginInstance->wpdb->get_var("SELECT print_div from $lwscPluginInstance->lwsc_table_name where name = '$name' ")== 1){
            echo "<div id='lwscAnchor-".$name."'></div>";
        }
    }
}
?>